/*
 * Copyright (c) 2015 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*global define, history, document */

/**
 * Application module.
 * @namespace SoundManager/app
 * @memberof SoundManager
 */

define({
    name: 'app',
    requires: [
        'core/event',
        'core/application',
        'core/systeminfo',

        'views/main',
        'views/details'
    ],
    def: function initApp(req) {
        'use strict';

        /**
         * Event core module.
         * @type {Module}
         */
        var e = req.core.event,

            /**
             * Application core module.
             * @type {Module}
             */
            app = req.core.application,

            /**
             * SystemInfo core module.
             * @type {Module}
             */
            sysInfo = req.core.systeminfo;

        /**
         * Registers event listeners.
         */
        function bindEvents() {
            document.addEventListener('tizenhwkey', function onTizenhwkey(e) {
                if (e.keyName === 'back') {
                    if (document.getElementsByClassName('ui-page-active')[0]
                            .id === 'main') {
                        app.exit();
                    } else {
                        history.back();
                    }
                }
            });
            sysInfo.listenBatteryLowState();
        }

        /**
         * Handles low battery state.
         */
        function onLowBattery() {
            app.exit();
        }

        /**
         * Initializes module.
         * @memberof SoundManager/app
         */
        function init() {
            bindEvents();
            sysInfo.checkBatteryLowState();
            e.listeners({
                'core.systeminfo.battery.low': onLowBattery
            });
        }

        return {
            init: init
        };
    }
});
